# description: little authorization script, you can make account via priv msg, script can regain 
# your op/halfop/voice, recover your password etc, authorization via login and password, multiple channels are supported, scripts adds public commands for owners, like: !aop, !ahop, !avoice <add|del> <#chan> <account>

# Author: tomekk
# e-mail:  tomekk/@/oswiecim/./eu/./org
# home page: http://tomekk.oswiecim.eu.org/
#
# Version 0.5
#
# This file is Copyrighted under the GNU Public License.
# http://www.gnu.org/copyleft/gpl.html

# PLEASE READ THIS AT FIRST! SECURITY TIP!
# before use this script you should disable 'm' mode in your config file (example: logfile mco * "logs/eggdrop.log" ==> logfile co * "logs/eggdrop.log"), or you can disable 'm' only for one channel, whatever...
# because all private messages (passwords, security-code etc) are landing in logfile as plain text
# whole authentication system using priv message channel, then my advice, remove 'm' from log options...

# normally all password, security-codes in database are encrypted (MD5)

# commands (for bot owners, you can change it at bind if you want ... if you know what are you doing):
# !aop <add|del> <#chan> <account> - adds/removes account from op list
# !ahop <add|del> <#chan> <account> - adds/removes account from halfop list
# !avoice <add|del> <#chan> <account> - adds/removes account from voice list
# !accs - show all accounts
# !accs <#chan> - shows accounts with op/halfop/voice lists signed to specified channel
# !lock <account> ... <account> - locks account/accounts
# !unlock <account> ... <account> - unlocks account/accounts
# !locks - shows list with locked accounts
# !stats <account> ... <account>  - shows account/accounts basic statistics
# !drop <account> ... <account> - removes account/accounts from database
# !lout - logouts all users
# !lout <account> ... <account> - logouts chosen user/users or all users
# !lgd - shows which accounts are currently in use
# !lgd <account> ... <account> - shows logged accounts handles
# !chan - shows defined channels list
# !chan [<add|del> <#chan>] - adds/removes channel definitions
# /msg <botnick> info - shows help for private messages 

# examples:
# we have two accounts, foo and bar
# at first, we need to make a channel files
# 	!chan add #my.channel
# at second, we need to "connect" existing accounts with channel
# 	!aop add #my.channel foo
# 	!avoice add #my.channel bar
# now, user foo can get +o on #my.channel and user bar can get +v on #my.channel by using command /msg <botnick> give <#chan> <op|hop|voice>
# i decided to remove the auto voice/op/hop on join, if you want "your mode" on join make some auto command in your irc client with /msg <botnick> login <account_name> <password> and /msg <botnick> give <#chan> <op|hop|voice>

# THIS VERSION IS NOT COMPATIBLE WITH VERSION 0.1 FILES, PLEASE DELETE OLD DATA DIR, FILES

# if you want to use commands from this script on your chan, type in eggdrop console (via telnet or DCC chat)
# .chanset #channel_name +lg
# and later .save

# fixed: fixed ssn generator, now is possible to use /dev/urandom on unix systems or normal rand() for windows systems to generate ssn key
# fixed: security issue, in prev versions script was checking ident@host of user, but there can be two or more users with the same ident@host, now script is using nick!ident@host
# fixed: if you want to use this script on your chan, use .chanset #channel_name +lg instead of setting channel name in variable (read above)
# fixed: some code/text fixes
# added: nick change proc, because now bot is making handle with nick!ident@host, script must tracking user nick changes

namespace eval tklogin {
	# variables
	variable lg_bind

	# begin of configuration

		# regain op/halfop/voice for authed users
		# 0 - disable
       		# 1 - enable
		variable lg_regain 1

		# log out all users after bot restart/rehash
		# 0 - disable
		# 1 - enable
		variable lg_logout_rr 1

		# type of ssn generator
		# 0 - /dev/urandom good for unix systems
		# 1 - rand() good for windows systems, of course this will work on unix too
		variable lg_ssn_gen 1

		# regexp for register, changepwd, recoverpwd commands (account name and password fields only)
		# you don't have to use A-Z because all account names and passwords are in lower case
		variable lg_input_regexp {^[a-z0-9]+$}

		# binds - change them if you need
		# chan
	 	set lg_bind(auto_op_add) "!aop"
		set lg_bind(auto_voice_add) "!avoice"
		set lg_bind(auto_halfop_add) "!ahop"
		set lg_bind(drop_accounts) "!drop"
		set lg_bind(show_accounts) "!accs"
		set lg_bind(logout_account) "!lout"
		set lg_bind(chan_mgmt) "!chan"
		set lg_bind(lock_account) "!lock"
		set lg_bind(show_locked) "!locks"
		set lg_bind(unlock_account) "!unlock"
		set lg_bind(show_authed) "!lgd"
		set lg_bind(show_stats) "!stats"
		# priv
		set lg_bind(register_cmd) "register"
		set lg_bind(unregister_cmd) "unregister"
		set lg_bind(login_cmd) "login"
		set lg_bind(logout_cmd) "logout"
		set lg_bind(change_pass_cmd) "changepwd"
		set lg_bind(recover_pass_cmd) "recoverpwd"
		set lg_bind(info_cmd) "info"
		set lg_bind(give_cmd) "give"
		set lg_bind(stats_cmd) "statsme"
		# messages (just two for now)
		set lg_bind(info_message) "available commands: register, unregister, login, logout, give, changepwd, recoverpwd, statsme - for more information use: /msg <botnick> <command>"
		set lg_bind(regexp_fail) "only letters and numbers are allowed in password and account name, try again"

		# login dbs dir
		variable lg_login_dir "login_db"

		# dir with channels files
		variable lg_channels_dir "$lg_login_dir/channels"

		# locks db
		variable locks "$lg_login_dir/locks.db"

		# users db
		variable ufile "$lg_login_dir/users.db"

		# auths db
		variable lfile "$lg_login_dir/authed.db"

		# stats db 
		variable sfile "$lg_login_dir/stats.db"

	# end of configuration
###############################################################################################
bind pub n|n $lg_bind(auto_op_add) ::tklogin::aop_fct
bind pub n|n $lg_bind(auto_voice_add) ::tklogin::avoice_fct
bind pub n|n $lg_bind(auto_halfop_add) ::tklogin::ahop_fct
bind pub n|n $lg_bind(drop_accounts) ::tklogin::drop_fct
bind pub n|n $lg_bind(show_accounts) ::tklogin::accs_fct
bind pub n|n $lg_bind(logout_account) ::tklogin::lout_fct
bind pub n|n $lg_bind(chan_mgmt) ::tklogin::chan_fct
bind pub n|n $lg_bind(lock_account) ::tklogin::lock_fct
bind pub n|n $lg_bind(show_locked) ::tklogin::locks_fct
bind pub n|n $lg_bind(unlock_account) ::tklogin::unlock_fct
bind pub n|n $lg_bind(show_authed) ::tklogin::lgd_fct
bind pub n|n $lg_bind(show_stats) ::tklogin::stats_fct

bind msgm -|- "*" ::tklogin::pmsg_fct
bind nick -|- "*" ::tklogin::nick_fct

if {$lg_regain == 1} {
	bind mode - "*-o*" ::tklogin::regain_op_fct
	bind mode - "*-h*" ::tklogin::regain_hop_fct
	bind mode - "*-v*" ::tklogin::regain_v_fct
}

setudef flag lg

if {![file exists $lg_login_dir]} {
	# if login main dir does not exist then we can make new dir and .holder cause it will be 0.3
	file mkdir $lg_login_dir
	set make_holder [open $lg_login_dir/.holder w]
	puts $make_holder "0.3\nplease don't remove this file, it's for tklogin dbase auto-converter procedure ;-)"
	close $make_holder
}

if {![file exists $lg_channels_dir]} {
	file mkdir $lg_channels_dir
}

if {![file exists $ufile]} {
	set file_handle [open $ufile w]
	close $file_handle
}

if {![file exists $lfile]} {
	set file_handle [open $lfile w]
        close $file_handle
}

if {![file exists $locks]} {
	set file_handle [open $locks w]
	close $file_handle
}

if {![file exists $sfile]} {
	set file_handle [open $sfile w]
	close $file_handle
}

if {$lg_logout_rr == 1} {
	set file_handle [open $lfile w]
	close $file_handle
}

set sep_char [binary format H* "1e"]

proc ::tklogin::fetch_db_data { dbbfile } {
	set file_handle [open $dbbfile]
	set all_data [read $file_handle]
	close $file_handle

	set all_lines [split $all_data "\n"]
	return $all_lines
}

# convert db from 0.2 to 0.3, runs only once (ver 0.2)
proc ::tklogin::convert_db_2_to_3 { } {
	variable lg_login_dir
	variable lfile
	variable ufile
	variable sfile
	variable sep_char
	variable lg_logout_rr

	if {![file exists $lg_login_dir/.holder]} {
		# convert users.db entries to new version, copy users to new stats db
		if {[file size $ufile] > 0} {
			file copy -force $ufile "$ufile\_old"
			set old_users_data [::tklogin::fetch_db_data $ufile]

			if {![string match *$sep_char* $old_users_data]} {
				set new_stats_db [open $sfile w]
				set new_users_db [open $ufile w]
				foreach old_user $old_users_data {
					if {$old_user != ""} {
						set line_rows [split $old_user ":"]
						set f_row [lindex $line_rows 0]
						set s_row [lindex $line_rows 1]
						set t_row [lindex $line_rows 2]

						set new_stat [split "$f_row 0 0 0 0 0 - -"]
						puts $new_stats_db [join $new_stat $sep_char]

						puts $new_users_db "$f_row$sep_char$s_row$sep_char$t_row"
					}
				}
				close $new_users_db
				close $new_stats_db
			}
		}

		# make .holder
		set touch_holder [open $lg_login_dir/.holder w]
		puts $touch_holder "0.3\nplease don't remove this file, it's for tklogin dbase auto-converter procedure ;-)"
		close $touch_holder

		putlog "tklogin - dbases converted from 0.2 to 0.3"
	}
}

::tklogin::convert_db_2_to_3

proc ::tklogin::lg_add_user { adata afile } {
	set file_handle [open $afile a]
	puts $file_handle $adata
	close $file_handle
}

proc ::tklogin::lg_del_user { duser dfile } {
	set all_lines [::tklogin::fetch_db_data $dfile]

	set file_handle [open $dfile w]
	foreach mode_user $all_lines {
		if {$mode_user != ""} {
			if {$duser != $mode_user} {
				puts $file_handle $mode_user
			}
		}
	}
        close $file_handle
}

proc ::tklogin::lg_if_exist { euser efile } {
	set usr_exist 0

	foreach each_user [::tklogin::fetch_db_data $efile] {
		if {$each_user == $euser} {
			set usr_exist 1
			break
		}
	}

	return $usr_exist
}

proc ::tklogin::check_if_exist_user { user ufile } {
	variable sep_char

	set usr_exist 0

	foreach line [::tklogin::fetch_db_data $ufile] {
		set luser [lindex [split $line $sep_char] 0]
		if {$luser == $user} {
			set usr_exist 1
			break
		}
	}

	return $usr_exist
}

proc ::tklogin::drop_data { ddata dfile } {
	variable sep_char

	set all_db_lines [::tklogin::fetch_db_data $dfile]

	set new_db_hand [open $dfile w]
	foreach db_user $all_db_lines {
		if {$db_user != ""} {
			set the_usr_name [lindex [split $db_user $sep_char] 0]

			if {$ddata != $the_usr_name} {
				puts $new_db_hand $db_user
			}
		}
	}
	close $new_db_hand
}	

proc ::tklogin::get_usr_info { user } {
	variable ufile
	variable sep_char

	set all_lines [::tklogin::fetch_db_data $ufile]

	set user_data [list]

	foreach db_user $all_lines {
		if {$db_user != ""} {
			set splt_data [split $db_user $sep_char]
			set user_acc [lindex $splt_data 0]

			if {$user == $user_acc} {
				set user_data [lrange $splt_data 1 2]
				break
			}
		}
	}

	return $user_data
}												

proc ::tklogin::del_acc_from_chans { acc } {
	variable lg_channels_dir
	
	set chans_names [glob -tails -directory $lg_channels_dir -nocomplain -type d *]

	set usr_files {opers voices hopers}

	foreach chan_name $chans_names { 
		if {$chan_name != ""} {
			foreach usr_chan_file $usr_files {
				::tklogin::lg_del_user $acc "$lg_channels_dir/$chan_name/$usr_chan_file"
			}
		}
	}
}

proc ::tklogin::ident_to_account { ident } {
	variable lfile
	variable sep_char

	set all_ident_lines [::tklogin::fetch_db_data $lfile]

	set account_name 0
	
	foreach db_ident $all_ident_lines {
		if {$db_ident != ""} {
			set splt_data [split $db_ident $sep_char]
			set user_acc [lindex $splt_data 0]
			set user_ident [lindex $splt_data 1]

			if {$ident == $user_ident} {
				set account_name $user_acc
				break
			}
		}
	}

	return $account_name
}										

proc ::tklogin::update_usr_info { user usr_data } {
	variable ufile
	variable sep_char

	set all_lines [::tklogin::fetch_db_data $ufile]

	set update_users [open $ufile w]
	foreach db_user $all_lines {
		if {$db_user != ""} {
			set user_name [lindex [split $db_user $sep_char] 0]
			if {$user == $user_name} {
				puts $update_users $usr_data
			} {
				puts $update_users $db_user
			}
		}
	}
	close $update_users
}

proc ::tklogin::get_stats_info { account } {
	variable sfile
	variable sep_char

	set stats_hand [open $sfile]
	set all_stats_data [split [read $stats_hand] "\n"]
	close $stats_hand

	set stats_data 0

	foreach stats_acc $all_stats_data {
		if {$stats_acc != ""} {
			set stats_acc_name [lindex [split $stats_acc $sep_char] 0]

			if {$stats_acc_name == $account} {
				set stats_data $stats_acc
				break;
			}
		}
	}

	return $stats_data
}

proc ::tklogin::output_f_stats { account } {
	variable sep_char

	set acc_stats_data [::tklogin::get_stats_info $account]

	set formated_stats ""

	if {$acc_stats_data != 0} {
		set sep_stats_data [split $acc_stats_data $sep_char]
		set acc_crt_date [lindex $sep_stats_data 1]
		set l_count [lindex $sep_stats_data 2]
		set fail_l_count  [lindex $sep_stats_data 3]
		set last_l_date [lindex $sep_stats_data 4]
		set last_f_l_date [lindex $sep_stats_data 5]
		set l_host [lindex $sep_stats_data 6]
		set l_f_host [lindex $sep_stats_data 7]

		if {$acc_crt_date == 0} {
			set acc_crt_date "-"
		} {
			set acc_crt_date [clock format $acc_crt_date -format %H:%M@%d/%m/%Y]
		}

		if {$last_l_date == 0} {
			set last_l_date "-"
		} {
			set last_l_date [clock format $last_l_date -format %H:%M@%d/%m/%Y]
		}

		if {$last_f_l_date == 0} {
			set last_f_l_date "-"
		} {
			set last_f_l_date [clock format $last_f_l_date -format %H:%M@%d/%m/%Y]
		}

		set formated_stats "$account account stats: creation date - $acc_crt_date, login count - $l_count, fail login count - $fail_l_count, last login date - $last_l_date ($l_host), last fail login date - $last_f_l_date ($l_f_host)"
	} {
		set formated_stats "account $account doesn't exists"
	}
	return $formated_stats
}

proc ::tklogin::pmsg_fct { nick uhost hand arg } {
	variable ufile 
	variable lfile 
	variable lg_channels_dir
	variable locks
	variable sep_char
	variable sfile
	variable lg_ssn_gen
	variable lg_bind
	variable lg_input_regexp

	set lg_txt [split [string tolower $arg]]
	set lg_main_cmd [lindex $lg_txt 0]
	set lg_opt_1 [lindex $lg_txt 1]
	set lg_opt_2 [lindex $lg_txt 2]
	set lg_opt_3 [lindex $lg_txt 3]
	set lg_opt_4 [lindex $lg_txt 4]

	if {$lg_main_cmd == $lg_bind(register_cmd)} {
		if {$lg_opt_3 != ""} {
			if {([regexp $lg_input_regexp $lg_opt_1]) && ([regexp $lg_input_regexp $lg_opt_2]) && ([regexp $lg_input_regexp $lg_opt_3])} {
				set act_name [::tklogin::ident_to_account "$nick\!$uhost"]
				if {[::tklogin::check_if_exist_user $act_name $lfile] == 0} {
					if {[::tklogin::check_if_exist_user $lg_opt_1 $ufile] == 0} {
						if {$lg_opt_2 == $lg_opt_3} {
							if {$lg_ssn_gen == 0} {
								set open_dev [open "/dev/urandom" r]
								set ssn_string [read $open_dev 16]
								close $open_dev
							} {
								set ssn_string [expr floor(rand() * [clock seconds])]
							}

							set ssn [md5 $ssn_string]
							set crt_seconds [clock seconds]

							::tklogin::lg_add_user "$lg_opt_1$sep_char[md5 $lg_opt_2]$sep_char[md5 $ssn]" $ufile
							set new_stat [split "$lg_opt_1 $crt_seconds 0 0 0 0 - -"]
							::tklogin::lg_add_user [join $new_stat $sep_char] $sfile
							putquick "PRIVMSG $nick :account $lg_opt_1 successfully registered, your security-code: $ssn"
							putquick "PRIVMSG $nick :please save this code, if you forget your password you will need it for password recovery, you can try to log in now"
						
						} {
							putquick "PRIVMSG $nick :you typed wrong password, try again"
						}
					} {
						putquick "PRIVMSG $nick :account $lg_opt_1 is already registered"
					}
				} {
					putquick "PRIVMSG $nick :you can't use this command now, please log out at first"
				}
			} {
				putquick "PRIVMSG $nick :$lg_bind(regexp_fail)"
			}
		} {
			putquick "PRIVMSG $nick :use: /msg <botname> register <account_name> <password> <retype_password>"
		}
	}

	if {$lg_main_cmd == $lg_bind(unregister_cmd)} {
		set u_act_name [::tklogin::ident_to_account "$nick\!$uhost"]
		if {[::tklogin::check_if_exist_user $u_act_name $lfile] == 1} {
			if {[::tklogin::lg_if_exist $u_act_name $locks] == 0} {
				::tklogin::drop_data $u_act_name $ufile
				::tklogin::drop_data $u_act_name $lfile
				::tklogin::drop_data $u_act_name $sfile				
				::tklogin::del_acc_from_chans $u_act_name
				::tklogin::lg_del_user $u_act_name $locks
				putquick "PRIVMSG $nick :account $u_act_name deleted"
			} {
				putquick "PRIVMSG $nick :your account is locked"
			}
		} {
			putquick "PRIVMSG $nick :you are not authed"
		}
	}
	
	if {$lg_main_cmd == $lg_bind(login_cmd)} {
		if {$lg_opt_2 != ""} {
			if {[::tklogin::check_if_exist_user $lg_opt_1 $ufile] == 1} {
				if {[::tklogin::lg_if_exist $lg_opt_1 $locks] == 0} {
					set l_act_name [::tklogin::ident_to_account "$nick\!$uhost"]
					if {([::tklogin::check_if_exist_user $lg_opt_1 $lfile] == 0) && ([::tklogin::check_if_exist_user $l_act_name $lfile] == 0)} {
						set user_own_data [::tklogin::get_usr_info $lg_opt_1]
						set acc_stats_data [::tklogin::get_stats_info $lg_opt_1]

						set sep_stats_data [split $acc_stats_data $sep_char]
						set acc_crt_date [lindex $sep_stats_data 1]
						set l_count [lindex $sep_stats_data 2]
						set fail_l_count  [lindex $sep_stats_data 3]
						set last_l_date [lindex $sep_stats_data 4]
						set last_f_l_date [lindex $sep_stats_data 5]
						set l_host [lindex $sep_stats_data 6]
						set l_f_host [lindex $sep_stats_data 7]

						set usr_pass [lindex $user_own_data 0]
	
						if {[md5 $lg_opt_2] == $usr_pass} {
							putquick "PRIVMSG $nick :successfully authed as $lg_opt_1"
							::tklogin::lg_add_user "$lg_opt_1$sep_char$nick\!$uhost" $lfile
							set update_stats [split "$lg_opt_1 $acc_crt_date [expr $l_count + 1] $fail_l_count [clock seconds] $last_f_l_date $uhost $l_f_host"]

						} {
							putquick "PRIVMSG $nick :you typed wrong password, try again"
							set update_stats [split "$lg_opt_1 $acc_crt_date $l_count [expr $fail_l_count + 1] $last_l_date [clock seconds] $l_host $uhost"]
						}

						set stats_db [open $sfile]
						set get_all_stats [split [read $stats_db] "\n"]
						close $stats_db

						set new_stats_db [open $sfile w]
						foreach stats_acc $get_all_stats {
							if {$stats_acc != ""} {
								set stats_acc_name [lindex [split $stats_acc $sep_char] 0]
								if {$stats_acc_name == $lg_opt_1} {
									puts $new_stats_db [join $update_stats $sep_char]
								} {
									puts $new_stats_db $stats_acc
								}
							}
						}
						close $new_stats_db
					} {
						putquick "PRIVMSG $nick :you are already authed or someone other is using your account"
					}	
				} {
					putquick "PRIVMSG $nick :your account is locked"
				}
			} {
				putquick "PRIVMSG $nick :account $lg_opt_1 is not registered"
			}
		} {
			putquick "PRIVMSG $nick :use: /msg <botname> login <account_name> <password>"
		}
	}
	
	if {$lg_main_cmd == $lg_bind(logout_cmd)} {
		set lo_act_name [::tklogin::ident_to_account "$nick\!$uhost"]
		if {[::tklogin::check_if_exist_user $lo_act_name $lfile] == 1} {
			::tklogin::drop_data $lo_act_name $lfile
			putquick "PRIVMSG $nick :successfully logged out"	
       		} {
			putquick "PRIVMSG $nick :you are not authed"
		}
	}
	
	if {$lg_main_cmd == $lg_bind(change_pass_cmd)} {
		if {$lg_opt_3 != ""} {
			if {([regexp $lg_input_regexp $lg_opt_1]) && ([regexp $lg_input_regexp $lg_opt_2]) && ([regexp $lg_input_regexp $lg_opt_3])} {
				set c_act_name [::tklogin::ident_to_account "$nick\!$uhost"]
				if {[::tklogin::check_if_exist_user $c_act_name $lfile] == 1} {
					if {[::tklogin::lg_if_exist $c_act_name $locks] == 0} {
						set user_own_data [::tklogin::get_usr_info $c_act_name]
						set usr_pass [lindex $user_own_data 0]
						set usr_ssn [lindex $user_own_data 1]
			
						if {($usr_pass == [md5 $lg_opt_1]) && ($lg_opt_2 == $lg_opt_3)} {
							::tklogin::update_usr_info $c_act_name "$c_act_name$sep_char[md5 $lg_opt_3]$sep_char$usr_ssn"
							putquick "PRIVMSG $nick :password for account $c_act_name successfully changed"
						} {
							putquick "PRIVMSG $nick :you typed wrong password, try again"
						}
					} {
						putquick "PRIVMSG $nick :your account is locked"
					}
				} {
					putquick "PRIVMSG $nick :you are not authed"
				}
			} {
				putquick "PRIVMSG $nick :$lg_bind(regexp_fail)"
			}
		} {
			putquick "PRIVMSG $nick :use: /msg <botname> changepwd <old_password> <new_password> <retype_new_password>"
		}
	}

	if {$lg_main_cmd == $lg_bind(recover_pass_cmd)} {
		if {$lg_opt_4 != ""} {
			if {([regexp $lg_input_regexp $lg_opt_1]) && ([regexp $lg_input_regexp $lg_opt_3]) && ([regexp $lg_input_regexp $lg_opt_4])} {
				if {[::tklogin::check_if_exist_user $lg_opt_1 $ufile] == 1} {
					if {[::tklogin::lg_if_exist $lg_opt_1 $locks] == 0} {
						set user_own_data [::tklogin::get_usr_info $lg_opt_1]
						set usr_ssn [lindex $user_own_data 1]
						if {$usr_ssn == [md5 $lg_opt_2]} {
							if {$lg_opt_3 == $lg_opt_4} {
								::tklogin::update_usr_info $lg_opt_1 "$lg_opt_1$sep_char[md5 $lg_opt_4]$sep_char$usr_ssn"
								::tklogin::drop_data $lg_opt_1 $lfile
								putquick "PRIVMSG $nick :password for account $lg_opt_1 successfully changed"
							} {
								putquick "PRIVMSG $nick :you typed wrong password, try again"
							}
						} {
							putquick "PRIVMSG $nick :you typed wrong security-code, try again"
						}
					} {
						putquick "PRIVMSG $nick :your account is locked"
					}
				} {
					putquick "PRIVMSG $nick :account $lg_opt_1 is not registered"			
				}
			} {
				putquick "PRIVMSG $nick :$lg_bind(regexp_fail)"
			}
		} {
			putquick "PRIVMSG $nick :use: /msg <botname> recoverpwd <account_name> <security_code> <new_password> <retype_new_password>"
		}
	}
	
	if {$lg_main_cmd == $lg_bind(info_cmd)} {
		putquick "PRIVMSG $nick :$lg_bind(info_message)"

	}
	
	if {$lg_main_cmd == $lg_bind(give_cmd)} {
		if {$lg_opt_2 != ""} {
			set g_act_name [::tklogin::ident_to_account "$nick\!$uhost"]
			if {[::tklogin::check_if_exist_user $g_act_name $lfile] == 1} {
				if {[::tklogin::lg_if_exist $g_act_name $locks] == 0} {
					if {[file exists $lg_channels_dir/$lg_opt_1]} {
						switch -- $lg_opt_2 {
							"op" {
								if {[::tklogin::lg_if_exist $g_act_name $lg_channels_dir/$lg_opt_1/opers] == 1} {
									 if {[botonchan $lg_opt_1] && [botisop $lg_opt_1]} {
										 if {[onchan $nick $lg_opt_1]} {
											 putquick "MODE $lg_opt_1 +o $nick"
										 } {
											 putquick "PRIVMSG $nick :you are not on this channel"
										 }
									 }
								 } {
									 putquick "PRIVMSG $nick :you are not on the opers list for this channel"
								 }
							}
	
							"halfop" {
								if {[::tklogin::lg_if_exist $g_act_name $lg_channels_dir/$lg_opt_1/hopers] == 1} {
									 if {[botonchan $lg_opt_1] && [botisop $lg_opt_1]} {
										 if {[onchan $nick $lg_opt_1]} {
											 putquick "MODE $lg_opt_1 +h $nick"
										 } {
											 putquick "PRIVMSG $nick :you are not on this channel"
										 }
									 }
								 } {
									 putquick "PRIVMSG $nick :you are not on the hopers list for this channel"
								 }
							}
	
							"voice" {
								if {[::tklogin::lg_if_exist $g_act_name $lg_channels_dir/$lg_opt_1/voices] == 1} {
									 if {[botonchan $lg_opt_1] && [botisop $lg_opt_1]} {
										 if {[onchan $nick $lg_opt_1]} {
											 putquick "MODE $lg_opt_1 +v $nick"
										 } {
											 putquick "PRIVMSG $nick :you are not on this channel"
										 }
									 }					 
								} {
									putquick "PRIVMSG $nick :you are not on the voices list for this channel"
								}
							}
						}
					} {
						putquick "PRIVMSG $nick :modes for $lg_opt_1 are not defined"
					}
				} {
					putquick "PRIVMSG $nick :your account is locked"
				}
			} {
				putquick "PRIVMSG $nick :you are not authed"
			}
		} {
			putquick "PRIVMSG $nick :use: /msg <botname> give <#chan> <op|halfop|voice>"
		}
	}

	if {$lg_main_cmd == $lg_bind(stats_cmd)} {
		set s_act_name [::tklogin::ident_to_account "$nick\!$uhost"]
		if {[::tklogin::check_if_exist_user $s_act_name $lfile] == 1} {
			if {[::tklogin::lg_if_exist $s_act_name $locks] == 0} {
				putquick "PRIVMSG $nick :[::tklogin::output_f_stats $s_act_name]"
			} {
				putquick "PRIVMSG $nick :your account is locked"
			}
		} {
			putquick "PRIVMSG $nick :you are not authed"
		}
	}
}

proc ::tklogin::aop_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable lg_channels_dir 
	variable ufile

	if {![channel get $chan lg]} {
		return
	}

	set input_args [split [string tolower $arg]]
	set cmd_type [lindex $input_args 0]
	set cmd_value [lindex $input_args 1]
	set cmd_value2 [lindex $input_args 2]

	if {$cmd_value2 != ""} {
		switch -- $cmd_type {
			"add" {
				if {[file exists $lg_channels_dir/$cmd_value]} {
					if {[::tklogin::check_if_exist_user $cmd_value2 $ufile] == 1} {
						if {[::tklogin::lg_if_exist $cmd_value2 $lg_channels_dir/$cmd_value/opers] == 0} {

							::tklogin::lg_add_user $cmd_value2 "$lg_channels_dir/$cmd_value/opers"
							putquick "NOTICE $nick :done"
						} {
							putquick "NOTICE $nick :user is already on list"
						}
					} {
						putquick "NOTICE $nick :account $cmd_value2 doesn't exists"
					}
				} {
					putquick "NOTICE $nick :channel file doesn't exists"
				}
			}

			"del" {
				if {[file exists $lg_channels_dir/$cmd_value]} {
					if {[::tklogin::check_if_exist_user $cmd_value2 $ufile] == 1} {
						if {[::tklogin::lg_if_exist $cmd_value2 $lg_channels_dir/$cmd_value/opers] == 1} {
							::tklogin::lg_del_user $cmd_value2 "$lg_channels_dir/$cmd_value/opers"
							putquick "NOTICE $nick :done"		
						} {
							putquick "NOTICE $nick :user isn't on the list"
						}
					} {
						putquick "NOTICE $nick :account $cmd_value2 doesn't exists"
					}
				} {
					putquick "NOTICE $nick :channel file doesn't exists"
				}
			}
		}
	} {
		putquick "NOTICE $nick :use: !aop <add|del> <#chan> <account>"
	}
}

proc ::tklogin::ahop_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable lg_channels_dir 
	variable ufile

	if {![channel get $chan lg]} {
		return
	}

	set input_args [split [string tolower $arg]]
	set cmd_type [lindex $input_args 0]
	set cmd_value [lindex $input_args 1]
	set cmd_value2 [lindex $input_args 2]

	if {$cmd_value2 != ""} {
		switch -- $cmd_type {
			"add" {
				if {[file exists $lg_channels_dir/$cmd_value]} {
					if {[::tklogin::check_if_exist_user $cmd_value2 $ufile] == 1} {
						if {[::tklogin::lg_if_exist $cmd_value2 $lg_channels_dir/$cmd_value/hopers] == 0} {

							::tklogin::lg_add_user $cmd_value2 "$lg_channels_dir/$cmd_value/hopers"
							putquick "NOTICE $nick :done"
						} {
							putquick "NOTICE $nick :user is already on list"
						}
					} {
						putquick "NOTICE $nick :account $cmd_value2 doesn't exists"
					}
				} {
					putquick "NOTICE $nick :channel file doesn't exists"
				}
			}

			"del" {
				if {[file exists $lg_channels_dir/$cmd_value]} {
					if {[::tklogin::check_if_exist_user $cmd_value2 $ufile] == 1} {
						if {[::tklogin::lg_if_exist $cmd_value2 $lg_channels_dir/$cmd_value/hopers] == 1} {
							::tklogin::lg_del_user $cmd_value2 "$lg_channels_dir/$cmd_value/hopers"
							putquick "NOTICE $nick :done"		
						} {
							putquick "NOTICE $nick :user isn't on the list"
						}
					} {
						putquick "NOTICE $nick :account $cmd_value2 doesn't exists"
					}
				} {
					putquick "NOTICE $nick :channel file doesn't exists"
				}
			}
		}
	} {
		putquick "NOTICE $nick :use: !ahop <add|del> <#chan> <account>"
	}
}

proc ::tklogin::avoice_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable lg_channels_dir 
	variable ufile

	if {![channel get $chan lg]} {
		return
	}

	set input_args [split [string tolower $arg]]
	set cmd_type [lindex $input_args 0]
	set cmd_value [lindex $input_args 1]
	set cmd_value2 [lindex $input_args 2]

	if {$cmd_value2 != ""} {
		switch -- $cmd_type {
			"add" {
				if {[file exists $lg_channels_dir/$cmd_value]} {
					if {[::tklogin::check_if_exist_user $cmd_value2 $ufile] == 1} {
						if {[::tklogin::lg_if_exist $cmd_value2 $lg_channels_dir/$cmd_value/voices] == 0} {

							::tklogin::lg_add_user $cmd_value2 "$lg_channels_dir/$cmd_value/voices"
							putquick "NOTICE $nick :done"
						} {
							putquick "NOTICE $nick :user is already on list"
						}
					} {
						putquick "NOTICE $nick :account $cmd_value2 doesn't exists"
					}
				} {
					putquick "NOTICE $nick :channel file doesn't exists"
				}
			}

			"del" {
				if {[file exists $lg_channels_dir/$cmd_value]} {
					if {[::tklogin::check_if_exist_user $cmd_value2 $ufile] == 1} {
						if {[::tklogin::lg_if_exist $cmd_value2 $lg_channels_dir/$cmd_value/voices] == 1} {
							::tklogin::lg_del_user $cmd_value2 "$lg_channels_dir/$cmd_value/voices"
							putquick "NOTICE $nick :done"		
						} {
							putquick "NOTICE $nick :user isn't on the list"
						}
					} {
						putquick "NOTICE $nick :account $cmd_value2 doesn't exists"
					}
				} {
					putquick "NOTICE $nick :channel file doesn't exists"
				}
			}
		}
	} {
		putquick "NOTICE $nick :use: !avoice <add|del> <#chan> <account>"
	}
}

proc ::tklogin::lout_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable lfile

	if {![channel get $chan lg]} {
		return
	}

	set input_args [split [string tolower $arg]]
	set nicks [lrange $input_args 0 end]

	if {$nicks == ""} {
		set clear_auth [open $lfile w]
		close $clear_auth
		putquick "NOTICE $nick :done"
	} {
		foreach in_nick $nicks {
			set in_nick [join $in_nick]
			::tklogin::drop_data $in_nick $lfile
		}
		putquick "NOTICE $nick :done"
	}
}

proc ::tklogin::drop_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable ufile 
	variable lfile
	variable sfile
	variable locks

	if {![channel get $chan lg]} {
		return
	}

	set input_args [split [string tolower $arg]]
        set nicks [lrange $input_args 0 end]

	set is_done 0

	if {$nicks != ""} {
		foreach d_nick $nicks {
			if {$d_nick != ""} {
				set d_nick [join $d_nick]
				if {[::tklogin::check_if_exist_user $d_nick $ufile] == 1} {
					::tklogin::drop_data $d_nick $ufile
					::tklogin::drop_data $d_nick $lfile
					::tklogin::del_acc_from_chans $d_nick
					::tklogin::lg_del_user $d_nick $locks
					::tklogin::drop_data $d_nick $sfile

					set is_done 1
				} {
					putquick "NOTICE $nick :account $d_nick doesn't exists"
				}
			}
		}
	} {
		putquick "NOTICE $nick :use: !drop <account> ... <account>"
	}

	if {$is_done == 1} {
		putquick "NOTICE $nick :done"
	}
}

proc ::tklogin::accs_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable lg_channels_dir 
	variable ufile
	variable sep_char

	if {![channel get $chan lg]} {
                return
	}

	set input_args [split [string tolower $arg]]
	set cmd_value [lindex $input_args 0]
	set cmd_value2 [lindex $input_args 1]

	if {$cmd_value != ""} {
		if {[regexp {^#.+} $cmd_value]} {
			if {[file exists $lg_channels_dir/$cmd_value]} {
				set opers_list [list]
				set hopers_list [list]
				set voices_list [list]

				foreach db_chan_o_acc [::tklogin::fetch_db_data $lg_channels_dir/$cmd_value/opers] {
					if {$db_chan_o_acc != ""} {
						lappend opers_list $db_chan_o_acc
					}
				}

				foreach db_chan_h_acc [::tklogin::fetch_db_data $lg_channels_dir/$cmd_value/hopers] {
					if {$db_chan_h_acc != ""} {
						lappend hopers_list $db_chan_h_acc
					}
				}

				foreach db_chan_v_acc [::tklogin::fetch_db_data $lg_channels_dir/$cmd_value/voices] {
					if {$db_chan_v_acc != ""} {
						lappend voices_list $db_chan_v_acc
					}
				}

				if {$opers_list == ""} {
					putquick "NOTICE $nick :opers list for $cmd_value: none"
				} {
					putquick "NOTICE $nick :opers list for $cmd_value: [join $opers_list ", "]"
				}

				if {$hopers_list == ""} {
					putquick "NOTICE $nick :hopers list for $cmd_value: none"
				} {
					putquick "NOTICE $nick :hopers list for $cmd_value: [join $hopers_list ", "]"
				}

				if {$voices_list == ""} {
					putquick "NOTICE $nick :voices list for $cmd_value: none"
				} {
					putquick "NOTICE $nick :voices list for $cmd_value: [join $voices_list ", "]"
				}
			} {
				putquick "NOTICE $nick :channel file doesn't exists"
			}
		} {
			putquick "NOTICE $nick :use: !accs <#chan>"
		}
	} {
		set user_names_list [list]

		foreach db_acc [::tklogin::fetch_db_data $ufile] {
			if {$db_acc != ""} {
				set just_name [lindex [split $db_acc $sep_char] 0]
				lappend user_names_list $just_name
			}
		}

		if {$user_names_list == ""} {
			putquick "NOTICE $nick :accounts list: none"
		} {
			putquick "NOTICE $nick :accounts list: [join $user_names_list ", "]"
		}
	}
}

proc ::tklogin::chan_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable lg_channels_dir

	if {![channel get $chan lg]} {
		return
	}

	set chan [string tolower $chan]

	set input_args [split [string tolower $arg]]
	set cmd_type [lindex $input_args 0]
	set cmd_value [lindex $input_args 1]

	if {$cmd_value != ""} {
		switch -- $cmd_type {
			"add" {
				if {[regexp {^#.+} $cmd_value]} {
					if {![file exists $lg_channels_dir/$cmd_value]} {
						file mkdir $lg_channels_dir/$cmd_value

						set usr_files {opers voices hopers}

						foreach new_file $usr_files {
							set make_new [open $lg_channels_dir/$cmd_value/$new_file w]
							close $make_new
						}

						putquick "NOTICE $nick :done"
					} {
						putquick "NOTICE $nick :channel file already exists"
					}
				} {
					putquick "NOTICE $nick :use: !chan add <#chan>"
				}
			}

			"del" {
				if {[regexp {^#.+} $cmd_value]} {
					if {[file exists $lg_channels_dir/$cmd_value]} {
						file delete -force $lg_channels_dir/$cmd_value
						putquick "NOTICE $nick :done"
					} {
						putquick "NOTICE $nick :channel file doesn't exists"
					}
				} {
					putquick "NOTICE $nick :use: !chan del <#chan>"
				}
			}
		}
	} {
		set channels_defs [join [glob -tails -directory $lg_channels_dir -nocomplain -type d *] ", "]

		if {$channels_defs == ""} {
			putquick "NOTICE $nick :defined channels: none"
		} {
			putquick "NOTICE $nick :defined channels: $channels_defs"
		}
	}
}

proc ::tklogin::lock_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels
	variable locks
	variable ufile
	variable lfile

	if {![channel get $chan lg]} {
		return
	}

	set splt_arg [split [string tolower $arg]]

	set is_done 0

	if {$splt_arg != ""} {
		foreach act_name $splt_arg {
			if {[::tklogin::lg_if_exist $act_name $locks] == 0} {
				if {[::tklogin::check_if_exist_user $act_name $ufile]} {
					::tklogin::lg_add_user $act_name $locks
					set act_name [::tklogin::ident_to_account "$nick\!$uhost"]
					::tklogin::drop_data $act_name $lfile
					set is_done 1
				} {
					putquick "NOTICE $nick :account $act_name doesn't exists"
				}
			} {
				putquick "NOTICE $nick :account $act_name is already locked"
			}
		}
	} {
		putquick "NOTICE $nick :use: !lock <account> ... <account>"
	}

	if {$is_done == 1} {
		putquick "NOTICE $nick :done"
	}
}

proc ::tklogin::locks_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels
	variable locks

	if {![channel get $chan lg]} {
		return
	}

	set locked_accs [join [lrange [fetch_db_data $locks] 0 end-1] ", "]

	if {$locked_accs != ""} {
		putquick "NOTICE $nick :locked accounts: $locked_accs"
	} {
		putquick "NOTICE $nick :locked accounts: none"
	}
}

proc ::tklogin::unlock_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels
	variable locks
	variable ufile

	if {![channel get $chan lg]} {
		return
	}

	set splt_arg [split [string tolower $arg]]

	set is_done 0

	if {$splt_arg != ""} {
		foreach act_name $splt_arg {
			if {[::tklogin::check_if_exist_user $act_name $ufile]} {
				if {[::tklogin::lg_if_exist $act_name $locks] == 1} {
					::tklogin::lg_del_user $act_name $locks
					set is_done 1
				} {
					putquick "NOTICE $nick :account $act_name is not locked"
				}
			} {
				putquick "NOTICE $nick :account $act_name doesn't exists"
			}
		}	
	 } {
		 putquick "NOTICE $nick :use: !unlock <account> ... <account>"
	 }

	 if {$is_done == 1} {
		 putquick "NOTICE $nick :done"
	 }
}

proc ::tklogin::lgd_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels
	variable lfile
	variable sep_char

	if {![channel get $chan lg]} {
                return
        }

	set splt_arg [split [string tolower $arg]]

	set acc_list [::tklogin::fetch_db_data $lfile]

	set acc_exists 0

	if {$splt_arg != ""} {
		foreach arg_acc $splt_arg {
			foreach authed_acc $acc_list {
				if {$authed_acc != ""} {
					set acc_data [split $authed_acc $sep_char]
					set act_name [lindex $acc_data 0]
					set acc_host [lindex $acc_data 1]

					if {$act_name == $arg_acc} {
						putquick "NOTICE $nick :$act_name account handle: $acc_host"
						set acc_exists 1
					}
				}
			}

			if {$acc_exists == 0} {
				putquick "NOTICE $nick :$arg_acc is not authed"
			}

			set acc_exists 0
		}
	} {
		set lgd_list [list]

		foreach authed_acc $acc_list {
			if {$authed_acc != ""} {
				set act_name [lindex [split $authed_acc $sep_char] 0]
				lappend lgd_list $act_name
			}
		}
	
		if {$lgd_list != ""} {
			putquick "NOTICE $nick :accounts in use: [join $lgd_list ", "]"
		} {
			putquick "NOTICE $nick :accounts in use: none"
		}
	}
}

proc ::tklogin::stats_fct { nick uhost hand chan arg } {
	variable lg_cmds_channels 
	variable ufile
	variable sep_char

	if {![channel get $chan lg]} {
		return
        }

	set splt_arg [split [string tolower $arg]]

	if {$splt_arg != ""} {
		foreach stat_acc $splt_arg {
			putquick "NOTICE $nick :[::tklogin::output_f_stats $stat_acc]"
		}
	} {
		putquick "NOTICE $nick :use: !stats <account> ... <account>"
	}
}

proc ::tklogin::regain_op_fct { nick uhost hand chan mode victim } {
	variable lfile 
	variable lg_channels_dir

	if {![channel get $chan lg]} {
		return
	}

	if {($nick != $victim) && ([isbotnick $victim] == 0)} {
		set user_host [getchanhost $victim $chan]
		set act_name [::tklogin::ident_to_account "$victim\!$user_host"]

		set chan [string tolower $chan]

		if {[::tklogin::check_if_exist_user $act_name $lfile] == 1} {
			if {[file exists $lg_channels_dir/$chan/opers]} {
				if {[::tklogin::lg_if_exist $act_name $lg_channels_dir/$chan/opers] == 1} {
					putquick "MODE $chan +o $victim"
				}
			}
		}
	}
}

proc ::tklogin::regain_hop_fct { nick uhost hand chan mode victim } {
	variable lfile 
	variable lg_channels_dir

	if {![channel get $chan lg]} {
		return
	}

	if {($nick != $victim) && ([isbotnick $victim] == 0)} {
		set user_host [getchanhost $victim $chan]
		set act_name [::tklogin::ident_to_account "$victim\!$user_host"]

		set chan [string tolower $chan]

		if {[::tklogin::check_if_exist_user $act_name $lfile] == 1} {
			if {[file exists $lg_channels_dir/$chan/hopers]} {
				if {[::tklogin::lg_if_exist $act_name $lg_channels_dir/$chan/hopers] == 1} {
					putquick "MODE $chan +h $victim"
				}
			}
		}
	}
}

proc ::tklogin::regain_v_fct { nick uhost hand chan mode victim } {
	variable lfile 
	variable lg_channels_dir

	if {![channel get $chan lg]} {
		return
	}

	if {($nick != $victim) && ([isbotnick $victim] == 0)} {
		set user_host [getchanhost $victim $chan]
		set act_name [::tklogin::ident_to_account "$victim\!$user_host"]

		set chan [string tolower $chan]

		if {[::tklogin::check_if_exist_user $act_name $lfile] == 1} {
			if {[file exists $lg_channels_dir/$chan/voices]} {
				if {[::tklogin::lg_if_exist $act_name $lg_channels_dir/$chan/voices] == 1} {
					putquick "MODE $chan +v $victim"
				}
			}
		}
	}
}

proc ::tklogin::nick_fct { nick uhost hand chan newnick } {
	variable sep_char
	variable lfile

	set get_all_logged [::tklogin::fetch_db_data $lfile]

	set user_logged 0

	set user_handle "$nick\!$uhost"
	set user_new_handle "$newnick\!$uhost"

	foreach each_logged $get_all_logged {
		if {$each_logged != ""} {
			set split_line [split $each_logged $sep_char]
			set user_hand_part [lindex $split_line 1]

			if {$user_hand_part == $user_handle} {
				set user_logged 1
				break
			}
		}
	}

	if {$user_logged == 1} {
		set update_lfile [open $lfile w]
		foreach new_each_logged $get_all_logged {
			if {$new_each_logged != ""} {
				set new_split_line [split $new_each_logged $sep_char]
				set new_user_acc_name [lindex $new_split_line 0]
				set new_user_hand_part [lindex $new_split_line 1]

				if {$new_user_hand_part == $user_handle} {
					puts $update_lfile "$new_user_acc_name$sep_char$user_new_handle"
				} {
					puts $update_lfile $new_each_logged
				}
			}
		}
		close $update_lfile
	}
}

putlog "tklogin.tcl ver 0.5 by tomekk loaded"

# end of namespace
} 
